Loading...
Searching...
No Matches
rig_state Struct Reference
Rig (transceiver) API

Rig state containing live data and customized fields. More...

`#include <rig_state.h>`

Collaboration diagram for rig_state:
[legend]

## Data Fields

hamlib_port_t_deprecated | rigport_deprecated
hamlib_port_t_deprecated | pttport_deprecated
hamlib_port_t_deprecated | dcdport_deprecated
double | vfo_comp
int | deprecated_itu_region
freq_range_t | rx_range_list [HAMLIB_FRQRANGESIZ]
freq_range_t | tx_range_list [HAMLIB_FRQRANGESIZ]
struct tuning_step_list | tuning_steps [HAMLIB_TSLSTSIZ]
struct filter_list | filters [HAMLIB_FLTLSTSIZ]
cal_table_t | str_cal
chan_t | chan_list [HAMLIB_CHANLSTSIZ]
shortfreq_t | max_rit
shortfreq_t | max_xit
shortfreq_t | max_ifshift
ann_t | announces
int | preamp [HAMLIB_MAXDBLSTSIZ]
int | attenuator [HAMLIB_MAXDBLSTSIZ]
setting_t | has_get_func
setting_t | has_set_func
setting_t | has_get_level
setting_t | has_set_level
setting_t | has_get_parm
setting_t | has_set_parm
gran_t | level_gran [RIG_SETTING_MAX]
gran_t | parm_gran [RIG_SETTING_MAX]
int | transaction_active
vfo_t | current_vfo
int | vfo_list
int | comm_state
rig_ptr_t | priv
rig_ptr_t | obj
int | async_data_enabled
int | poll_interval
freq_t | current_freq
rmode_t | current_mode
pbwidth_t | current_width
vfo_t | tx_vfo
rmode_t | mode_list
int | transmit
freq_t | lo_freq
time_t | twiddle_time
int | twiddle_timeout
int | uplink
HL_DEPRECATED struct rig_cache_deprecated | cache
int | vfo_opt
int | auto_power_on
int | auto_power_off
int | auto_disable_screensaver
int | ptt_share
int | power_now
int | power_min
int | power_max
unsigned char | disable_yaesu_bandselect
int | twiddle_rit
int | twiddle_state
vfo_t | rx_vfo
volatile unsigned int | snapshot_packet_sequence_number
volatile int | multicast_publisher_run
void * | multicast_publisher_priv_data
volatile int | async_data_handler_thread_run
void * | async_data_handler_priv_data
volatile int | poll_routine_thread_run
void * | poll_routine_priv_data
pthread_mutex_t | mutex_set_transaction
hamlib_port_t | rigport
hamlib_port_t | pttport
hamlib_port_t | dcdport
int | use_cached_freq
int | use_cached_mode
int | use_cached_ptt
int | depth
int | lock_mode
powerstat_t | powerstat
char * | tuner_control_pathname
char | client_version [32]
freq_t | offset_vfoa
freq_t | offset_vfob
struct multicast_s * | multicast
rig_model_t | rig_model
const char * | model_name
const char * | mfg_name
const char * | version
const char * | copyright
enum rig_status_e | status
int | rig_type
ptt_type_t | ptt_type
dcd_type_t | dcd_type
rig_port_t | port_type
int | serial_rate_min
int | serial_rate_max
int | serial_data_bits
int | serial_stop_bits
enum serial_parity_e | serial_parity
enum serial_handshake_e | serial_handshake
int | write_delay
int | post_write_delay
int | timeout
int | retry
int | targetable_vfo
int | async_data_supported
int | agc_level_count
enum agc_level_e | agc_levels [HAMLIB_MAX_AGC_LEVELS]
tone_t * | ctcss_list
tone_t * | dcs_list
vfo_op_t | vfo_ops
scan_t | scan_ops
int | transceive
int | bank_qty
int | chan_desc_sz
freq_range_t | rx_range_list1 [HAMLIB_FRQRANGESIZ]
freq_range_t | tx_range_list1 [HAMLIB_FRQRANGESIZ]
freq_range_t | rx_range_list2 [HAMLIB_FRQRANGESIZ]
freq_range_t | tx_range_list2 [HAMLIB_FRQRANGESIZ]
freq_range_t | rx_range_list3 [HAMLIB_FRQRANGESIZ]
freq_range_t | tx_range_list3 [HAMLIB_FRQRANGESIZ]
freq_range_t | rx_range_list4 [HAMLIB_FRQRANGESIZ]
freq_range_t | tx_range_list4 [HAMLIB_FRQRANGESIZ]
freq_range_t | rx_range_list5 [HAMLIB_FRQRANGESIZ]
freq_range_t | tx_range_list5 [HAMLIB_FRQRANGESIZ]
struct rig_spectrum_scope | spectrum_scopes [HAMLIB_MAX_SPECTRUM_SCOPES]
enum rig_spectrum_mode_e | spectrum_modes [HAMLIB_MAX_SPECTRUM_MODES]
freq_t | spectrum_spans [HAMLIB_MAX_SPECTRUM_SPANS]
struct rig_spectrum_avg_mode | spectrum_avg_modes [HAMLIB_MAX_SPECTRUM_AVG_MODES]
int | spectrum_attenuator [HAMLIB_MAXDBLSTSIZ]
volatile int | morse_data_handler_thread_run
void * | morse_data_handler_priv_data
struct FIFO_RIG_s * | fifo_morse
int | doppler
char * | multicast_data_addr
int | multicast_data_port
char * | multicast_cmd_addr
int | multicast_cmd_port
volatile int | multicast_receiver_run
void * | multicast_receiver_priv_data
rig_comm_status_t | comm_status
char | device_id [HAMLIB_RIGNAMSIZ]
int | dual_watch
int | post_ptt_delay
struct timespec | freq_event_elapsed
int | freq_skip
client_t | client
pthread_mutex_t | api_mutex

## Detailed Description

Rig state containing live data and customized fields.

This struct contains live data, as well as a copy of capability fields that may be updated (ie. customized)

It is NOT fine to move fields around as it can break shared library offset As of 2024-03-03 freq_event_elapsed is the last known item being reference externally So any additions or changes to this structure must be at the end of the structure

## Field Documentation

## agc_level_count

int rig_state::agc_level_count

Number of supported AGC levels. Zero indicates all modes should be available (for backwards-compatibility).

## agc_levels

enum agc_level_e rig_state::agc_levels[HAMLIB_MAX_AGC_LEVELS]

Supported AGC levels

## announces

ann_t rig_state::announces

Announces bit field list

## api_mutex

pthread_mutex_t rig_state::api_mutex

Lock for any API entry.

## async_data_enabled

int rig_state::async_data_enabled

Whether async data mode is enabled

## async_data_handler_priv_data

void* rig_state::async_data_handler_priv_data

Pointer to async_data_handler_priv_data.

## async_data_handler_thread_run

volatile int rig_state::async_data_handler_thread_run

Async data handler thread run flag.

## async_data_supported

int rig_state::async_data_supported

Indicates that rig is capable of outputting asynchronous data updates, such as transceive state updates or spectrum data. 1 if true, 0 otherwise.

## attenuator

int rig_state::attenuator[HAMLIB_MAXDBLSTSIZ]

Attenuator list in dB, 0 terminated

## auto_disable_screensaver

int rig_state::auto_disable_screensaver

Allow Hamlib to disable the rig's screen saver automatically if supported

## auto_power_off

int rig_state::auto_power_off

Allow Hamlib to power off rig automatically if supported

## auto_power_on

int rig_state::auto_power_on

Allow Hamlib to power on rig automatically if supported

## bank_qty

int rig_state::bank_qty

Number of banks

## cache

HL_DEPRECATED struct rig_cache_deprecated rig_state::cache

Deprecated
  Only here for backward compatibility

## chan_desc_sz

int rig_state::chan_desc_sz

Max length of memory channel name

## chan_list

chan_t rig_state::chan_list[HAMLIB_CHANLSTSIZ]

Channel list, zero ended

## client

client_t rig_state::client

Client application of the library.

## client_version

char rig_state::client_version[32]

! Allow client to report version for compatibility checks/capability

## comm_state

int rig_state::comm_state

Comm port state, opened/closed.

## comm_status

rig_comm_status_t rig_state::comm_status

Detailed rig control status

## copyright

const char* rig_state::copyright

Copyright info.

## ctcss_list

tone_t* rig_state::ctcss_list

CTCSS tones list, zero ended

## current_freq

freq_t rig_state::current_freq

Frequency currently set

## current_mode

rmode_t rig_state::current_mode

Mode currently set

## current_vfo

vfo_t rig_state::current_vfo

VFO currently set

## current_width

pbwidth_t rig_state::current_width

Passband width currently set

## dcd_type

dcd_type_t rig_state::dcd_type

Type of the DCD port.

## dcdport

hamlib_port_t rig_state::dcdport

DCD port (internal use).

## dcdport_deprecated

hamlib_port_t_deprecated rig_state::dcdport_deprecated

Deprecated
  DCD port (internal use).

## dcs_list

tone_t* rig_state::dcs_list

DCS code list, zero ended

## deprecated_itu_region

int rig_state::deprecated_itu_region

Deprecated
  ITU region to select among freq_range_t

## depth

int rig_state::depth

a depth counter to use for debug indentation and such

## device_id

char rig_state::device_id[HAMLIB_RIGNAMSIZ]

Device name,

## disable_yaesu_bandselect

unsigned char rig_state::disable_yaesu_bandselect

Disables Yaesu band select logic

## doppler

int rig_state::doppler

True if doppler changing detected

## dual_watch

int rig_state::dual_watch

Boolean DUAL_WATCH status

## fifo_morse

struct FIFO_RIG_s* rig_state::fifo_morse

FIFO queue for Morse Code transmission.

## filters

struct filter_list rig_state::filters[HAMLIB_FLTLSTSIZ]

Mode/filter table, at -6dB

## freq_event_elapsed

struct timespec rig_state::freq_event_elapsed

Time struct used by various caches.

## freq_skip

int rig_state::freq_skip

allow frequency skip for gpredict RX/TX freq set

## has_get_func

setting_t rig_state::has_get_func

List of get functions

## has_get_level

setting_t rig_state::has_get_level

List of get level

## has_get_parm

setting_t rig_state::has_get_parm

List of get parm

## has_set_func

setting_t rig_state::has_set_func

List of set functions

## has_set_level

setting_t rig_state::has_set_level

List of set level

## has_set_parm

setting_t rig_state::has_set_parm

List of set parm

## level_gran

gran_t rig_state::level_gran[RIG_SETTING_MAX]

level granularity

## lo_freq

freq_t rig_state::lo_freq

Local oscillator frequency of any transverter

## lock_mode

int rig_state::lock_mode

flag that prevents mode changes if ~= 0 – see set/get_lock_mode

## max_ifshift

shortfreq_t rig_state::max_ifshift

max absolute IF-SHIFT

## max_rit

shortfreq_t rig_state::max_rit

max absolute RIT

## max_xit

shortfreq_t rig_state::max_xit

max absolute XIT

## mfg_name

const char* rig_state::mfg_name

Manufacturer.

## mode_list

rmode_t rig_state::mode_list

Complete list of modes for this rig

## model_name

const char* rig_state::model_name

Model name.

## morse_data_handler_priv_data

void* rig_state::morse_data_handler_priv_data

Morse data handler private structure.

## morse_data_handler_thread_run

volatile int rig_state::morse_data_handler_thread_run

Morse data handler thread flag.

## multicast

struct multicast_s* rig_state::multicast

Pointer to multicast server data

## multicast_cmd_addr

char* rig_state::multicast_cmd_addr

Multicast command server UDP address for sending commands to rig

## multicast_cmd_port

int rig_state::multicast_cmd_port

Multicast command server UDP port for sending commands to rig

## multicast_data_addr

char* rig_state::multicast_data_addr

Multicast data UDP address for publishing rig data and state

## multicast_data_port

int rig_state::multicast_data_port

Multicast data UDP port for publishing rig data and state

## multicast_publisher_priv_data

void* rig_state::multicast_publisher_priv_data

Pointer to multicast_publisher_priv_data.

## multicast_publisher_run

volatile int rig_state::multicast_publisher_run

Multicast publisher run flag.

## multicast_receiver_priv_data

void* rig_state::multicast_receiver_priv_data

Multicast receiver private data structure,

## multicast_receiver_run

volatile int rig_state::multicast_receiver_run

Multicast receiver run flag.

## mutex_set_transaction

pthread_mutex_t rig_state::mutex_set_transaction

Thread mutex flag.

## obj

rig_ptr_t rig_state::obj

Internal use by hamlib++ for event handling.

## offset_vfoa

freq_t rig_state::offset_vfoa

Offset to apply to VFOA/Main set_freq

## offset_vfob

freq_t rig_state::offset_vfob

Offset to apply to VFOB/Sub set_freq

## parm_gran

gran_t rig_state::parm_gran[RIG_SETTING_MAX]

parm granularity

## poll_interval

int rig_state::poll_interval

Rig state polling period in milliseconds

## poll_routine_priv_data

void* rig_state::poll_routine_priv_data

Pointer to rig_poll_routine_priv_data.

## poll_routine_thread_run

volatile int rig_state::poll_routine_thread_run

Poll routine thread run flag.

## port_type

rig_port_t rig_state::port_type

Type of communication port.

## post_ptt_delay

int rig_state::post_ptt_delay

delay after PTT to allow for relays and such

## post_write_delay

int rig_state::post_write_delay

Delay between each commands send out, in mS

## power_max

int rig_state::power_max

Maximum RF power level in rig units

## power_min

int rig_state::power_min

Minimum RF power level in rig units

## power_now

int rig_state::power_now

Current RF power level in rig units

## powerstat

powerstat_t rig_state::powerstat

power status

## preamp

int rig_state::preamp[HAMLIB_MAXDBLSTSIZ]

Preamp list in dB, 0 terminated

## priv

rig_ptr_t rig_state::priv

Pointer to private rig state data.

## ptt_share

int rig_state::ptt_share

Share ptt port by open/close during get_ptt, set_ptt hogs the port while active

## ptt_type

ptt_type_t rig_state::ptt_type

Type of the PTT port.

## pttport

hamlib_port_t rig_state::pttport

PTT port (internal use).

## pttport_deprecated

hamlib_port_t_deprecated rig_state::pttport_deprecated

Deprecated
  PTT port (internal use).

## retry

int rig_state::retry

Maximum number of retries if command fails, 0 to disable

## rig_model

rig_model_t rig_state::rig_model

Rig model.

## rig_type

int rig_state::rig_type

Rig type.

## rigport

hamlib_port_t rig_state::rigport

Rig port (internal use).

## rigport_deprecated

hamlib_port_t_deprecated rig_state::rigport_deprecated

Deprecated
  Rig port (internal use).

## rx_range_list

freq_range_t rig_state::rx_range_list[HAMLIB_FRQRANGESIZ]

Receive frequency range list

## rx_range_list1

freq_range_t rig_state::rx_range_list1[HAMLIB_FRQRANGESIZ]

Receive frequency range list #1

## rx_range_list2

freq_range_t rig_state::rx_range_list2[HAMLIB_FRQRANGESIZ]

Receive frequency range list #2

## rx_range_list3

freq_range_t rig_state::rx_range_list3[HAMLIB_FRQRANGESIZ]

Receive frequency range list #3

## rx_range_list4

freq_range_t rig_state::rx_range_list4[HAMLIB_FRQRANGESIZ]

Receive frequency range list #4

## rx_range_list5

freq_range_t rig_state::rx_range_list5[HAMLIB_FRQRANGESIZ]

Receive frequency range list #5

## rx_vfo

vfo_t rig_state::rx_vfo

Rx VFO currently set

## scan_ops

scan_t rig_state::scan_ops

Scan bit field list

## serial_data_bits

int rig_state::serial_data_bits

Number of data bits.

## serial_handshake

enum serial_handshake_e rig_state::serial_handshake

Handshake.

## serial_parity

enum serial_parity_e rig_state::serial_parity

Parity.

## serial_rate_max

int rig_state::serial_rate_max

Maximum serial speed.

## serial_rate_min

int rig_state::serial_rate_min

Minimum serial speed.

## serial_stop_bits

int rig_state::serial_stop_bits

Number of stop bits.

## snapshot_packet_sequence_number

volatile unsigned int rig_state::snapshot_packet_sequence_number

Sequence number for JSON output.

## spectrum_attenuator

int rig_state::spectrum_attenuator[HAMLIB_MAXDBLSTSIZ]

Spectrum attenuator list in dB, 0 terminated

## spectrum_avg_modes

struct rig_spectrum_avg_mode rig_state::spectrum_avg_modes[HAMLIB_MAX_SPECTRUM_AVG_MODES]

Supported spectrum scope averaging modes. Last entry must have NULL name.

## spectrum_modes

enum rig_spectrum_mode_e rig_state::spectrum_modes[HAMLIB_MAX_SPECTRUM_MODES]

Supported spectrum scope modes. Last entry must be RIG_SPECTRUM_MODE_NONE.

## spectrum_scopes

struct rig_spectrum_scope rig_state::spectrum_scopes[HAMLIB_MAX_SPECTRUM_SCOPES]

Supported spectrum scopes. The array index must match the scope ID. Last entry must have NULL name.

## spectrum_spans

freq_t rig_state::spectrum_spans[HAMLIB_MAX_SPECTRUM_SPANS]

Supported spectrum scope frequency spans in Hz in center mode. Last entry must be 0.

## status

enum rig_status_e rig_state::status

Driver status.

## str_cal

cal_table_t rig_state::str_cal

S-meter calibration table

## targetable_vfo

int rig_state::targetable_vfo

Bit field list of direct VFO access commands

## timeout

int rig_state::timeout

Timeout, in mS

## transaction_active

int rig_state::transaction_active

set to 1 to inform the async reader thread that a synchronous command transaction is waiting for a response, otherwise 0

## transceive

int rig_state::transceive

Deprecated
  Use async_data_supported instead

## transmit

int rig_state::transmit

rig should be transmitting i.e. hard wired PTT asserted - used by rigs that don't do CAT while in Tx

## tuner_control_pathname

char* rig_state::tuner_control_pathname

Path to external tuner control program that get 0/1 (Off/On) argument

## tuning_steps

struct tuning_step_list rig_state::tuning_steps[HAMLIB_TSLSTSIZ]

Tuning step list

## twiddle_rit

int rig_state::twiddle_rit

Suppresses VFOB reading (cached value used) so RIT control can be used

## twiddle_state

int rig_state::twiddle_state

keeps track of twiddle status

## twiddle_time

time_t rig_state::twiddle_time

time when vfo twiddling was detected

## twiddle_timeout

int rig_state::twiddle_timeout

timeout to resume from twiddling

## tx_range_list

freq_range_t rig_state::tx_range_list[HAMLIB_FRQRANGESIZ]

Transmit frequency range list

## tx_range_list1

freq_range_t rig_state::tx_range_list1[HAMLIB_FRQRANGESIZ]

Transmit frequency range list #1

## tx_range_list2

freq_range_t rig_state::tx_range_list2[HAMLIB_FRQRANGESIZ]

Transmit frequency range list #2

## tx_range_list3

freq_range_t rig_state::tx_range_list3[HAMLIB_FRQRANGESIZ]

Transmit frequency range list #3

## tx_range_list4

freq_range_t rig_state::tx_range_list4[HAMLIB_FRQRANGESIZ]

Transmit frequency range list #4

## tx_range_list5

freq_range_t rig_state::tx_range_list5[HAMLIB_FRQRANGESIZ]

Transmit frequency range list #5

## tx_vfo

vfo_t rig_state::tx_vfo

Tx VFO currently set

## uplink

int rig_state::uplink

uplink=1 will not read Sub, uplink=2 will not read Main

## use_cached_freq

int rig_state::use_cached_freq

flag instructing rig_get_freq to use cached values when asyncio is in use

## use_cached_mode

int rig_state::use_cached_mode

flag instructing rig_get_mode to use cached values when asyncio is in use

## use_cached_ptt

int rig_state::use_cached_ptt

flag instructing rig_get_ptt to use cached values when asyncio is in use

## version

const char* rig_state::version

Driver version.

## vfo_comp

double rig_state::vfo_comp

VFO compensation in PPM, 0.0 to disable

## vfo_list

int rig_state::vfo_list

Complete list of VFO for this rig

## vfo_ops

vfo_op_t rig_state::vfo_ops

VFO op bit field list

## vfo_opt

int rig_state::vfo_opt

Is -o switch turned on?

## write_delay

int rig_state::write_delay

Delay between each byte sent out, in mS

The documentation for this struct was generated from the following file:

- rig_state.h